local mod = DBM:NewMod("Battlestandards","DBM-Battlestandards")
local L			= mod:GetLocalizedStrings();

mod:SetZone(DBM_DISABLE_ZONE_DETECTION);

mod:RegisterEvents(
    "SPELL_CAST_SUCCESS 23034 23035"
)

mod:AddBoolOption("ShowAlertsForOpposingFaction", true)
mod:RemoveOption("HealthFrame")
mod:RemoveOption("SpeedKillTimer")

local function IsOpposingFaction(factionGroup)
	local playerFactionGroup, playerFactionName = UnitFactionGroup("player");
	if factionGroup == playerFactionGroup then
		return false;
	else
		return true;
	end
end

local function GetFactionIcon(factionName)
	if factionName == "Alliance" then
         return "Interface\\Icons\\INV_BannerPVP_02.blp";
	 elseif factionName == "Horde" then
		 return"Interface\\Icons\\INV_BannerPVP_01.blp";
     end
end
 -- This is a little on the mad side, in a bg opposing faction will always the one player is not
local function GetNonLocalizedOpposingFactionInfo()
	 local factionGroup = "unknown";
	 local factionName  = "unknown";
	 local playerFactionGroup, playerFactionName = UnitFactionGroup("player");
	 if playerFactionGroup = "Alliance" then
		 factionName = "Horde";
		 factionGroup = "Horde";
	 else
		 factionName = "Alliance";
		 factionGroup = "Alliance";
	 end
	 
	 return factionGroup, factionName
end
	 
function mod:SPELL_CAST_SUCCESS(args)

     local class, classFilename, race, raceFilename, sex, name, realm = GetPlayerInfoByGUID(args.sourceGUID);
      
     local factionGroup, factionName = UnitFactionGroup(name);
	 
	 -- TODO : Doing the same thing twice in essence here, fix GetNonLocalizedOpposingFactionInfo(); then optimize
	 if factionGroup == nil or factionGroup == "unknown" then
		factionGroup, factionName = GetNonLocalizedOpposingFactionInfo();
	 end
	 
	 if ShowAlertsForOpposingFaction == false and IsOpposingFaction(factionGroup) then
		return;
	 end

     local factionIcon = GetFactionIcon(factionGroup)

     local message = mod:NewAnnounce("WarnStandardPlaced",2,factionIcon);
     message:Show(name,factionName);
	 
     local bar = mod:NewTimer(120,"StandardExpiryTimer",factionIcon);
     bar:Start(name,factionName);
       
     local expiredMessage = mod:NewAnnounce("WarnStandardExpired",4,factionIcon);
     expiredMessage:Schedule(120,name,factionName);
       
end